"""Autogenerated API schema"""
from argus_api import session


associate_events_with_case = {'tags': ['events/v2'], 'summary': 'Submit a list of event UUIDs with which to associate the specified case. (DEV)', 'description': '', 'operationId': 'associateEventsWithCase', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'caseID', 'in': 'path', 'description': 'Case ID', 'required': True, 'type': 'int', 'minimum': 1}, {'in': 'body', 'name': 'body', 'description': 'Associate case to events submission request', 'required': False, 'schema': {'type': 'object', 'required': ['events'], 'properties': {'events': {'type': 'list', 'position': 0, 'description': 'A list of events with which to associate the specified case.Can be given in the form of AGGR/1/123456789/{UUID} or simply UUID. ', 'items': {'type': 'string'}, 'maxItems': 2147483647, 'minItems': 1}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'accepted': {'type': 'int', 'position': 0, 'description': 'Number of events that haven been successfully associated with the case. '}, 'rejected': {'type': 'int', 'position': 0, 'description': 'Number of events that has failed to be associated with the case. '}, 'errorInfoList': {'type': 'list', 'position': 0, 'description': 'List of errors for each event that failed to be associated with the case. This field will have the same number and order of UUIDS in the request. ', 'items': {'type': 'dict', 'properties': {'submissionIndex': {'type': 'int', 'position': 0, 'description': 'Index of the submission as it appears in the request. '}, 'errorMessages': {'type': 'list', 'position': 0, 'description': 'String message of error cause. ', 'items': {'type': 'string'}}}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}
disassociate_events_from_case = {'tags': ['events/v2'], 'summary': 'Submit a list of event UUIDs to disassociate the specified case from. (DEV)', 'description': '', 'operationId': 'disassociateEventsFromCase', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'caseID', 'in': 'path', 'description': 'Case ID', 'required': True, 'type': 'int', 'minimum': 1}, {'in': 'body', 'name': 'body', 'description': 'Disassociate case from events submission request', 'required': False, 'schema': {'type': 'object', 'required': ['events'], 'properties': {'events': {'type': 'list', 'position': 0, 'description': 'A list of events to disassociate the specified case from. Can be given in the form of AGGR/1/123456789/{UUID} or simply UUID. ', 'items': {'type': 'string'}, 'maxItems': 2147483647, 'minItems': 1}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'accepted': {'type': 'int', 'position': 0, 'description': 'Number of events that has been successfully disassociated from the case. '}, 'rejected': {'type': 'int', 'position': 0, 'description': 'Number of events that has failed to be disassociated from the case. '}, 'errorInfoList': {'type': 'list', 'position': 0, 'description': 'List of errors for each event that failed to be disassociated from the case. This field will have the same number and order of UUIDS in the request. ', 'items': {'type': 'dict', 'properties': {'submissionIndex': {'type': 'int', 'position': 0, 'description': 'Index of the submission as it appears in the request. '}, 'errorMessages': {'type': 'list', 'position': 0, 'description': 'String message of error cause. ', 'items': {'type': 'string'}}}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}