"""Autogenerated API schema"""
from argus_api import session


submit_p_d_n_s_records_bulk = {'tags': ['pdns/v3'], 'summary': 'Submit PassiveDNS records in a bulk operation (DEV)', 'description': '', 'operationId': 'submitPDNSRecordsBulk', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'PDNS bulk submission request', 'required': False, 'schema': {'type': 'object', 'required': ['records'], 'properties': {'records': {'type': 'list', 'position': 0, 'description': 'PDNS records for submission. ', 'items': {'type': 'dict', 'required': ['answer', 'query', 'recordClass', 'recordType', 'tlp'], 'properties': {'lastSeen': {'type': 'int', 'position': 0, 'description': 'Last seen, defaults to reception from agent. Accepts ISO-8601 timestamp string. (default now)'}, 'firstSeen': {'type': 'int', 'position': 0, 'description': 'First time record was seen, usually is set by agent. Accepts ISO-8601 timestamp string. (default now)'}, 'times': {'type': 'int', 'position': 0, 'description': 'Incident count (default 1)', 'minimum': 1, 'default': 1}, 'minTTLSec': {'type': 'int', 'position': 0, 'description': 'Minimum Time to leave in seconds. ', 'minimum': 0}, 'maxTTLSec': {'type': 'int', 'position': 0, 'description': 'Max Time to leave in seconds. ', 'minimum': 0}, 'query': {'type': 'str', 'position': 0, 'description': 'Querying address '}, 'answer': {'type': 'str', 'position': 0, 'description': 'Answering address '}, 'customer': {'type': 'str', 'position': 0, 'description': 'ID or shortname of customer '}, 'tlp': {'type': 'str', 'position': 0, 'description': 'Traffic Light Protocol ', 'enum': ['white', 'green', 'amber', 'red']}, 'recordClass': {'type': 'str', 'position': 0, 'description': 'Record class type (default in)'}, 'recordType': {'type': 'str', 'position': 0, 'description': 'Record recordType '}}}, 'maxItems': 2147483647, 'minItems': 1}, 'ignoreOnFailed': {'type': 'bool', 'position': 0, 'description': 'Set this value for successful response even failures occur while submitting. (default false)', 'default': False}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'accepted': {'type': 'int', 'position': 0, 'description': 'Number of successfully submitted records. '}, 'rejected': {'type': 'int', 'position': 0, 'description': 'Number of records that failed validation. '}, 'errorInformationList': {'type': 'list', 'position': 0, 'description': 'Information regarding any records that rejected during validation. ', 'items': {'type': 'dict', 'properties': {'submissionIndex': {'type': 'int', 'position': 0, 'description': 'Index of the submission as it appears in the submission request. '}, 'errorMessages': {'type': 'list', 'position': 0, 'description': 'String message of error cause. ', 'items': {'type': 'string'}}}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}